"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HeadlessCmsContentEntry = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _appAdmin = require("@webiny/app-admin");
var _appHeadlessCms = require("@webiny/app-headless-cms");
var _reactRouter = require("@webiny/react-router");
var _ContentEntryGuard = require("./ContentEntryGuard");
var _ContentEntryLocker = require("./ContentEntryLocker");
var ContentEntry = _appHeadlessCms.ContentEntryEditorConfig.ContentEntry;
var DisablePrompt = (0, _appAdmin.createGenericContext)("DisablePrompt");
var PromptDecorator = _reactRouter.Prompt.createDecorator(function (Original) {
  return function Prompt(props) {
    var _DisablePrompt$useHoo = DisablePrompt.useHook(),
      disablePrompt = _DisablePrompt$useHoo.disablePrompt;
    var when = disablePrompt === true ? false : props.when;
    return /*#__PURE__*/_react.default.createElement(Original, {
      message: props.message,
      when: when
    });
  };
});
var ContentEntryDecorator = ContentEntry.createDecorator(function (Original) {
  return function RecordLockingContentEntry(props) {
    var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      disablePrompt = _useState2[0],
      setDisablePrompt = _useState2[1];
    var _ContentEntry$useCont = ContentEntry.useContentEntry(),
      entry = _ContentEntry$useCont.entry;
    /**
     * New entry does not have ID yet.
     */
    if (!entry?.id) {
      return /*#__PURE__*/_react.default.createElement(DisablePrompt.Provider, {
        disablePrompt: disablePrompt
      }, /*#__PURE__*/_react.default.createElement(Original, props));
    }
    /**
     * Continue with existing entry.
     */
    return /*#__PURE__*/_react.default.createElement(_ContentEntryGuard.ContentEntryGuard, null, /*#__PURE__*/_react.default.createElement(_ContentEntryLocker.ContentEntryLocker, {
      onDisablePrompt: function onDisablePrompt(flag) {
        return setDisablePrompt(flag);
      }
    }, /*#__PURE__*/_react.default.createElement(DisablePrompt.Provider, {
      disablePrompt: disablePrompt
    }, /*#__PURE__*/_react.default.createElement(Original, props))));
  };
});
var HeadlessCmsContentEntry = exports.HeadlessCmsContentEntry = function HeadlessCmsContentEntry() {
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(ContentEntryDecorator, null), /*#__PURE__*/_react.default.createElement(_appAdmin.CompositionScope, {
    name: "cms.contentEntryForm"
  }, /*#__PURE__*/_react.default.createElement(PromptDecorator, null)));
};

//# sourceMappingURL=HeadlessCmsContentEntry.js.map